mod result;
mod system;
mod platform;

use result::Result;

fn main() {
    if let Err(e) = init() {
        eprintln!("Error: {e}");
        let mut opt = Some(&e as &dyn std::error::Error);
        while let Some(current_source) = opt {
            eprintln!("Caused by: {current_source}");
            opt = current_source.source();
        }
    }
}

fn init() -> Result<()> {
    platform::init()?;
    println!("Hello, world!");

    Ok(())
}
