use crate::result::{Result, Context};

pub struct Aws;

impl Aws {
    fn init_heartbeat() -> Result<()> {
        Ok(())
    }
}

impl super::Platform for Aws {
    fn is(&self) -> Result<bool> {
        std::fs::exists("/dev/nsm").context(format_args!("could not check if /dev/nsm exists"))
    }

    fn get_modules(&self) -> Result<Vec<(String, String)>> {
        Ok(vec![
           ("/nsm.ko".into(), String::new())
        ])
    }

    fn init(&self) -> Result<()> {
        Self::init_heartbeat()?;
        Ok(())
    }
}
